## cupt 2.0.1

=== cpp/CMakeLists.txt ===
IF(EXISTS /usr/bin/g++-4.5)
	set(CMAKE_CXX_COMPILER /usr/bin/g++-4.5)
ELSE(EXISTS /usr/bin/g++-4.5)
	message(FATAL_ERROR "g++ 4.5.0 or greater required")
ENDIF(EXISTS /usr/bin/g++-4.5)

IF(NOT EXISTS /usr/include/boost/xpressive/xpressive_dynamic.hpp)
	message(FATAL_ERROR "missing Boost.Xpressive library")
ENDIF(NOT EXISTS /usr/include/boost/xpressive/xpressive_dynamic.hpp)

IF(NOT EXISTS /usr/include/boost/program_options.hpp)
	message(FATAL_ERROR "missing Boost.ProgramOptions library")
ENDIF(NOT EXISTS /usr/include/boost/program_options.hpp)

find_package(Boost 1.42.0)
IF(Boost_FOUND)
	IF(Boost_VERSION LESS 104200)
		message(FATAL_ERROR "need Boost of version 1.42.0")
	ENDIF(Boost_VERSION LESS 104200)
ELSE(Boost_FOUND)
	message(FATAL_ERROR "missing Boost")
ENDIF(Boost_FOUND)

IF(NOT EXISTS /usr/include/readline/readline.h)
	message(FATAL_ERROR "missing GNU Readline library")
ENDIF(NOT EXISTS /usr/include/readline/readline.h)

set(CMAKE_CXX_FLAGS "-Wall -Wextra -std=gnu++0x  -fPIC")

OPTION(VERBOSE "is build verbose")
IF(VERBOSE)
	set(CMAKE_VERBOSE_MAKEFILE TRUE)
ENDIF(VERBOSE)

OPTION(LOCAL "is build local" ON)
IF(LOCAL)
	set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DCUPT_LOCAL_BUILD")
ENDIF(LOCAL)

OPTION(OPTIMIZE "is build optimized")
IF(OPTIMIZE GREATER 0)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNDEBUG -O${OPTIMIZE}")
	IF(OPTIMIZE GREATER 1)
		# set(CMAKE_LD_FLAGS "${CMAKE_LD_FLAGS} -flto")
		# set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto")
	ENDIF(OPTIMIZE GREATER 1)
ENDIF(OPTIMIZE GREATER 0)

OPTION(PROFILE "for profiling")
IF(PROFILE)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ggdb")
ENDIF(PROFILE)

set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--as-needed")

MACRO(ADD_PRECOMPILED_HEADER Target)
	get_target_property(Sources ${Target} SOURCES)
	# message(STATUS "Sources found for ${Target}: ${Sources}")
	SET_SOURCE_FILES_PROPERTIES(${Sources}
		PROPERTIES
		COMPILE_FLAGS "-include ../precompiled/precompiled.hpp -Winvalid-pch"
	)
	add_dependencies(${Target} precompiled)
ENDMACRO(ADD_PRECOMPILED_HEADER)

set(CUPT_SOVERSION 0)

# detect version from debian/changelog
execute_process(
	COMMAND "dpkg-parsechangelog" "-l${PROJECT_SOURCE_DIR}/debian/changelog"
	COMMAND "grep" "^Version"
	COMMAND "cut" "-d " "-f" "2"
	OUTPUT_VARIABLE CUPT_VERSION
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

IF(CUPT_VERSION)
	message(STATUS "Detected Cupt version: ${CUPT_VERSION}")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DCUPT_VERSION=${CUPT_VERSION}")
ELSE(CUPT_VERSION)
	message(FATAL_ERROR "Unable to detect Cupt version.")
ENDIF(CUPT_VERSION)

add_subdirectory(console)
add_subdirectory(lib)
add_subdirectory(precompiled)
add_subdirectory(downloadmethods)

=== doc/CMakeLists.txt ===
IF(NOT EXISTS /usr/bin/doxygen)
	message(FATAL_ERROR "missing doxygen")
ENDIF(NOT EXISTS /usr/bin/doxygen)

IF(NOT EXISTS /usr/bin/txt2tags)
	message(FATAL_ERROR "missing txt2tags")
ENDIF(NOT EXISTS /usr/bin/txt2tags)

add_custom_command(
	OUTPUT doxygen-stamp
	DEPENDS cupt2
	WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/reference"

	COMMAND pwd
	COMMAND doxygen
	COMMAND touch ../doxygen-stamp
)
add_custom_command(
	MAIN_DEPENDENCY tutorial.t2t
	OUTPUT tutorial-stamp

	COMMAND txt2tags ARGS -t html -o tutorial.html tutorial.t2t
	COMMAND txt2tags ARGS -t man -o cupt_tutorial.7 tutorial.t2t
	COMMAND touch tutorial-stamp
)
add_custom_target(doc ALL DEPENDS doxygen-stamp tutorial-stamp)

install(DIRECTORY examples DESTINATION share/doc/lib)
install(DIRECTORY reference/html DESTINATION share/doc/lib)
install(DIRECTORY reference/man DESTINATION share FILES_MATCHING PATTERN cupt*)
install(FILES tutorial.html cupt_tutorial.7 DESTINATION share/doc)

=== cpp/console/CMakeLists.txt ===
include_directories(../lib/include)
add_executable(cupt.bin
	cupt.cpp
	misc.cpp
	handlers/search.cpp
	handlers/misc.cpp
	handlers/managepackages.cpp
	handlers/shell.cpp
	handlers/download.cpp
	handlers/snapshot.cpp
	selectors.cpp)
target_link_libraries(cupt.bin cupt2 boost_program_options)
add_precompiled_header(cupt.bin)

install(PROGRAMS cupt.bin DESTINATION bin RENAME cupt)

=== cpp/downloadmethods/CMakeLists.txt ===
include_directories(../lib/include)

add_library(wget MODULE wget.cpp)
add_precompiled_header(wget)
target_link_libraries(wget cupt2)

add_library(curl MODULE curl.cpp)
add_precompiled_header(curl)
target_link_libraries(curl cupt2 curl-gnutls)

add_library(debdelta MODULE debdelta.cpp)
add_precompiled_header(debdelta)
target_link_libraries(debdelta cupt2)

install(TARGETS wget curl debdelta DESTINATION lib/cupt2-${CUPT_SOVERSION}/downloadmethods)

=== cpp/lib/CMakeLists.txt ===
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DSOVERSION=${CUPT_SOVERSION} -fvisibility=hidden")

include_directories(include)
include_directories(src)
add_library(cupt2 SHARED
	./src/internal/common.cpp
	./src/internal/configparser.cpp
	./src/internal/nativeresolver/impl.cpp
	./src/internal/nativeresolver/solution.cpp
	./src/internal/nativeresolver/score.cpp
	./src/internal/nativeresolver/dependencygraph.cpp
	./src/internal/nativeresolver/decisionfailtree.cpp
	./src/internal/lock.cpp
	./src/internal/cacheimpl.cpp
	./src/internal/pininfo.cpp
	./src/internal/filesystem.cpp
	./src/internal/debdeltahelper.cpp
	./src/internal/tagparser.cpp
	./src/internal/worker/base.cpp
	./src/internal/worker/archives.cpp
	./src/internal/worker/metadata.cpp
	./src/internal/worker/setupandpreview.cpp
	./src/internal/worker/packages.cpp
	./src/internal/worker/snapshots.cpp
	./src/config.cpp
	./src/cache.cpp
	./src/cache/relation.cpp
	./src/cache/binarypackage.cpp
	./src/cache/binaryversion.cpp
	./src/cache/sourcepackage.cpp
	./src/cache/sourceversion.cpp
	./src/cache/package.cpp
	./src/cache/version.cpp
	./src/system/state.cpp
	./src/system/resolver.cpp
	./src/system/resolvers/native.cpp
	./src/system/worker.cpp
	./src/system/snapshots.cpp
	./src/download/uri.cpp
	./src/download/manager.cpp
	./src/download/method.cpp
	./src/download/methodfactory.cpp
	./src/download/progress.cpp
	./src/download/progresses/console.cpp
	./src/common.cpp
	./src/common/compareversions.cpp
	./src/common/consumers.cpp
	./src/file.cpp
	./src/regex.cpp
	./src/hashsums.cpp
	./src/pipe.cpp
)
set_target_properties(cupt2 PROPERTIES VERSION 2.0.0 SOVERSION ${CUPT_SOVERSION})
target_link_libraries(cupt2 dl rt gcrypt)
add_precompiled_header(cupt2)

install(TARGETS cupt2 DESTINATION lib)
install(DIRECTORY include/ DESTINATION include)

=== cpp/precompiled/CMakeLists.txt ===
string(REPLACE " " ";" CompileFlags ${CMAKE_CXX_FLAGS})
add_custom_command(
	OUTPUT precompiled.hpp.gch
	DEPENDS precompiled.hpp

	COMMAND ${CMAKE_CXX_COMPILER} -I../lib/include ${CompileFlags} -x c++-header -c precompiled.hpp -o precompiled.hpp.gch
)
add_custom_target(precompiled DEPENDS precompiled.hpp.gch)

## cupt 0.2.3

=== debian/changelog ===
cupt (0.2.3) unstable; urgency=medium

  * Cupt:
    - System:
      - Worker:
        - 'update_release_and_index_data': fixed downloading of non-compressed
          indexes.
        - 'update_release_and_index_data': fixed removing downloaded file after
          uncompressing.
        - 'update_release_and_index_data': remove the downloaded Release.gpg if
          signature verification failed and 'cupt::update::keep-bad-signatures'
          is false (this is the default setting) for the compatibility with APT.
          Thanks to Goswin von Brederlow <goswin-v-b@web.de>.
          (Closes: #533753). Urgency is set to 'medium' because of this fix.
        - 'update_release_and_index_data': download index file even if
          signature download/check failed.
      - Resolvers/Native:
        - Reworked solution rank system.
        - Dropped 'first-good' solution chooser. It can be mimicked by setting
          'max-solution-count' option to 1.
        - Run cleaning auto-installed packages also before resolving, aiming
          to reduce number of solutions resolver should work with.
        - Made "zero" line for actions 400 points less, affecting ordering
          solutions for processing for default 'fair' resolver type. Leads to
          significant (several times) speed-up for some cases. Makes possible
          to obtain at least one solution for some hard queries (like removing
          core system components).
        - Fixed erroneous auto-removing of some dependencies which were brought
          by 'satisfy' query.
    - Download:
      - Manager:
        - Enabled basic HTTPS protocol support.
        - IPC is rewritten using UNIX sockets instead of fifos.
      - Progress:
        - Changed speed-o-meter accuracy to 4 seconds (previous value was
          2 seconds).
      - Methods/Curl:
        - Added basic handling of transitive download errors.
    - Cache:
      - New free subroutine 'verify_signature'.
      - BinaryVersion:
        - [API break] Renamed field 'source_name' to 'source_package_name'.
        - Added a check for hash sums presence. Thanks to
          Goswin von Brederlow <goswin-v-b@web.de>.
        - Added a check for version string presence.
    - Config:
      - Added configuration option 'apt::cache-limit'. Thanks to
        Goswin von Brederlow <goswin-v-b@web.de>. (Closes: #533752)
      - New configuration option 'cupt::update::keep-bad-signatures'.
  * debian/control:
    - Bumped Standards-Version to 3.8.2, no changes needed.
    - Changed Homepage to wiki.debian.org/Cupt.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Sun, 21 Jun 2009 18:42:49 +0300

cupt (0.2.2) unstable; urgency=low

  * Cupt:
    - System:
      - Resolvers/Native:
        - When applying resolve actions, stick packages more aggressively.
      - Worker:
        - 'clean_archives': fixed callback before actual deletion.
        - 'clean_archives': delete only '.deb's.
        - 'clean_archives': fixed error message when deletion failed.
    - Core:
      - Comparing version strings: fixed comparison of versions like 'ab' and
        'ab5'.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Fri, 05 Jun 2009 19:40:19 +0300

cupt (0.2.1) unstable; urgency=low

  * cupt:
    - New 'screenshots' subcommand.
    - New 'clean' subcommand.
    - New 'autoclean' subcommand.
    - Implemented the option '--quiet'.
  * Cupt:
    - System:
      - Worker:
        - New 'clean_archives' method.
        - 'update_release_and_index_data': fixed deleting download progress
          immediately after end of all child processes.
        - 'update_release_and_index_data': don't download Packages/Sources
          when we know they are unchanged by provided hash sums.
      - Resolvers/Native:
        - Fixed dropping solutions by normalized score, not by the original one.
        - Fixed auto-removing of packages which resolver marked to change, but
          in the end they became unneeded anyway.
    - Cache:
      - BinaryVersion:
        - Always set 'source_version_string' field.
    - Config:
      - Added configuration option 'quiet'.
      - New configuration option 'debug::downloader'.
    - Download:
      - Progresses/Console:
        - Don't output progress meter when standard output is not a TTY.
      - Manager:
        - Worker thread: honor 'debug::downloader' configuration option.
        - Worker thread: fixed stucking in some complex conditions.

 -- Eugene V. Lyubimkin <jackyf.devel@gmail.com>  Tue, 02 Jun 2009 11:34:28 +0300

cupt (0.2.0) unstable; urgency=low

  * cupt:
    - New 'update' subcommand.
  * doc/cupt.1.pod:
    - Mentioned how to set list configuration option.
  * doc/cupt_howto.7.pod:
    - Added.
  * Cupt:
    - System:
      - Resolver*:
        - Merged an infrastructure to allow multiple resolvers to co-exist in
          future.
      - Worker:
        - [API break] 'do_actions' renamed to 'change_system'.
        - New method 'update_release_and_index_data'.
        - Honor 'dpkg::options' option.
    - Download:
      - Manager:
        - Worker thread: handle duplicated download requests that come when
          the original download request is not yet completed. This use case is
          possible 'update' action.
        - Worker thread: handle concurrent request of the same URI properly.
        - Worker thread: pass correct URI to download progress in case of
          ACKed download.
        - 'download' method: switched to modern interface of File::Temp,
          getting rid of compatibility one.
        - 'download' method: use POSIX::mkfifo instead of calling 'mkfifo'
          program.
        - 'download' method: return final download result back to worker
          thread only if this was requested.
        - New forwarding methods 'set_long_alias_for_uri' and
          'set_short_alias_for_uri'.
    - Cache:
      - 'get_pin' method: divided into 'get_original_apt_pin' and 'get_pin'
        methods.


=== debian/control ===
Source: cupt
Section: perl
Priority: optional
Build-Depends: debhelper (>= 7)
Build-Depends-Indep: perl (>= 5.10.0), liburi-perl, libparse-recdescent-perl,
  libwww-curl-perl (>= 4.05)
Maintainer: Eugene V. Lyubimkin <jackyf.devel@gmail.com>
DM-Upload-Allowed: yes
Homepage: http://wiki.debian.org/Cupt
Standards-Version: 3.8.2

Package: libcupt-perl
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}, perl (>= 5.10.0), liburi-perl,
  libwww-curl-perl (>= 4.05), libgraph-perl, libterm-size-perl,
  libparse-recdescent-perl, libdigest-sha-perl
Recommends: liblocale-gettext-perl, bzip2
Suggests: cupt, lzma
Description: alternative front-end for dpkg -- Perl modules
 This is a set of Cupt Perl modules implementing front-end to dpkg.
 .
 Provides:
  - parsing and manipulating configuration info;
  - parsing indexes metadata info;
  - version strings comparison;
  - inspection of the binary package' versions;
  - parsing and querying info about installed packages;
  - parsing and working with relations and relation expressions;
  - download manager and downloaders for some schemes;
  - problem resolver;
  - worker for modifying system state.
 .
 See also description of 'cupt' package for more information.

Package: cupt
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}, libcupt-perl (>= ${binary:Version})
Description: alternative front-end for dpkg -- console interface
 This package provides a console interface to Cupt library, which is a
 re-implementation of libapt-pkg C++ library using Perl. The aim is to produce
 more strict, more robust, less buggy front-end than APT.
 .
 Cupt uses the same APT infrastructure, e.g. index files, deb cache archive
 files, configuration files. It understands some of widely used APT options.
 .
 Some features:
  - strict full-case resolver;
  - resolver reasons tracking;
  - command-line and APT-like option name checker;
  - case-sensitive search;
  - pinning by source package name;
  - pinning by package groups using shell-like patterns;
  - configurable 'depends' and 'rdepends' subcommands;
  - 'satisfy' subcommand;
  - support of LZMA-compressed indexes.
 .
 Its interface is mostly like apt-get/aptitude console interface.

=== debian/rules ===
#!/usr/bin/make -f

ifndef PERL
	PERL=/usr/bin/perl
endif

build: build-stamp
build-stamp:
	$(PERL) Makefile.PL INSTALLDIRS=vendor
	touch $@

clean:
	dh $@

install: install-stamp
install-stamp: build-stamp
	dh install --before dh_auto_install
	$(MAKE) install PREFIX=$(CURDIR)/debian/libcupt-perl/usr
	# produce additional man pages for cupt
	perl debian/install_pods
	dh install --after dh_auto_install
	touch $@

binary-arch:

binary-indep: install
	dh $@

binary: binary-arch binary-indep

.PHONY: binary binary-arch binary-indep install clean build

## cupt 1.5.1

=== debian/changelog ===
cupt (1.5.1) unstable; urgency=low

  * Cupt:
    - System:
      - Worker:
        - 'change_system': perform download stage after determining dpkg call
          sequence.
        - Fixed the stupid long-standing bug with forgetting some action
          dependencies for relation expressions which involve several binary
          packages. Thanks to James Vega for spotting it. (Closes: #564724)
      - Resolvers/Native:
        - Significantly increased the penalty for removing installed packages.
        - Optimize building solution tree in case of actions that resolve
          conflicts with multiple packages that provide the same virtual
          package.
    - Config:
      - Added the 'aptlistbugs::*' option family. Thanks to Ryan Niebur.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Tue, 12 Jan 2010 14:02:06 +0200

cupt (1.5.0) unstable; urgency=low

  * cupt:
    - 'dist-upgrade': start completely new process in the second stage to fix
      the possible undefined behavior when libcupt-perl got upgrade in the
      first stage with the API changes.
    - 'depends': in recurse mode pick up only one new version for the relation
      expression by default, specify '--all-versions' to override.
  * Cupt:
    - Config:
      - New option family 'cupt::downloader::protocols::*::priority'.
      - New option family 'cupt::downloader::protocols::*::methods'.
      - New option family
        'cupt::downloader::protocols::*::methods::*::priority'.
    - Download:
      - Manager:
        - Sort URIs for the file by priorities.
      - Method:
        - Implemented choosing a method with maximum priority between several
          available ones.
    - System:
      - Resolvers/Native:
        - Adjusted calculating action weights so installing new version
          outweights non-upgrading another package in most cases, even
          automatically installed one. Thanks to James Vega. (Closes: #562797)
  * scripts/bash_completion:
    - Implemented bash completion for cupt program.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 02 Jan 2010 18:03:45 +0200

cupt (1.4.0) unstable; urgency=low

  * Cupt:
    - System:
      - Worker:
        - 'get_unpacked_sizes_preview': fixed a crash when purging the package
          in 'config-files' state but which has installation candidates.
          Thanks to Cyril Brulebois. (Closes: #559340)
      - Resolvers/Native:
        - Fixed the bug when soft dependencies were automatically removed in
          the start of resolving because of disappear of the parent packages
          and then weren't considered to keeping when other parent packages
          hierarchy declared a soft dependency on the package.
        - Apply 'automatically installed' penalty score to all versions of
          automatically installed packages, not only installed one.
        - Don't perform inner auto-removal before of main resolver cycles.
      - Resolvers/External:
        - Request: lowercased all fields.
        - Request: pass '>>' as '>' and '<<' as '<' in relation expressions.
        - Request: added the preable with a 'pin-priority' property
          declaration.
        - Request: 'problem' stanza is renamed to 'request'.
    - Download:
      - Methods/Debdelta:
        - Suppress standard output from debpatch.
    - Config:
      - [API break] 'set_regular_var': renamed to 'set_scalar'.
      - [API break] 'set_list_var': renamed to 'set_list'.
      - [API break] 'var': replaced by new methods 'get_string', 'get_number'
        and 'get_bool'.
    - Core:
      - Moved INIT block out to 'cupt' front-end.
    - Cache:
      - 'verify_signature': use gpgv, not gpg for checking.
      - BinaryVersion:
        - Fallback to 0 if the installed size is not defined. Thanks to
          Jean-Christophe Dubacq <jcdubacq1@free.fr>. (Closes: #560160)
  * debian/control:
    - Added the package 'gpgv' to Recommends of the 'libcupt-perl' package.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Tue, 15 Dec 2009 13:58:38 +0200

cupt (1.3.1) unstable; urgency=low

  * Cupt:
    - Config:
      - Added the option 'APT::Never-MarkAuto-Sections'.
      - Added the option family 'Aptitude::*'.
    - Cache:
      - 'verify_hash_sums': fixed the crash regression since 1.3.0. Thanks to
        Cyril Brulebois. (Closes: #557177)
    - Graph/TransitiveClosure:
      - Fixed calculating vertexes reachability for paths with length more
        than 2.
    - Worker:
      - While splitting heterogeneous actions, pay the first attention to
        action dependencies which are originated from 'Conflicts'. No longer
        pass '--force-conflicts' to dpkg. Thanks to James Vega.
        (Closes: #556650)
      - Mark the 'remove' subactions of upgrade/downgrade actions as fake.
      - Subsequently, don't try to "eat" some action dependencies anymore.
      - Don't merge unpack and configure subactions.
      - While splitting heterogeneous actions, ignore (after setting up
        '--force-breaks' and '--force-depends') reverse dependencies'
        breakages.
      - Allow circular dependencies between only 'configure' subactions, give
        up with an error on other ones.
      - Pass '--force-bad-path' to work around dpkg bug #558151.
    - Download:
      - Progresses/Console:
        - Fixed a divide-by-zero crash with zero-sized files. Thanks to
          James Vega. (Closes: #557661)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 30 Nov 2009 15:23:28 +0200

cupt (1.3.0) unstable; urgency=low

  * cupt:
    - 'rdepends': memoize parsed versions.
    - Management actions:
      - Support '@<file>' syntax for reading arguments from files. The idea of
        the patch by Jean-Christophe Dubacq. (Closes: #554356)
    - Don't crash when run with no parameters (once again). Thanks to
      Didier Raboud. (Closes: #547952)
  * Cupt:
    - Cache:
      - 'get_satisfying_versions': don't sort result.
      - 'get_sorted_pinned_versions': removed ability to memoize it.


=== debian/control ===
--- 
+++ 
@@ -1,21 +1,24 @@
 Source: cupt
 Section: perl
 Priority: optional
-Build-Depends: debhelper (>= 7)
+Build-Depends: debhelper (>= 7.0.50)
 Build-Depends-Indep: perl (>= 5.10.0), liburi-perl, libparse-recdescent-perl,
-  libwww-curl-perl (>= 4.05)
-Maintainer: Eugene V. Lyubimkin <jackyf.devel@gmail.com>
-DM-Upload-Allowed: yes
+  libwww-curl-perl (>= 4.05), liblist-moreutils-perl (>= 0.23)
+Maintainer: Eugene V. Lyubimkin <jackyf@debian.org>
 Homepage: http://wiki.debian.org/Cupt
-Standards-Version: 3.8.2
+Standards-Version: 3.8.3
+Vcs-Git: git://github.com/jackyf/cupt.git
+Vcs-Browser: http://github.com/jackyf/cupt/tree/master
 
 Package: libcupt-perl
 Architecture: all
 Depends: ${misc:Depends}, ${perl:Depends}, perl (>= 5.10.0), liburi-perl,
-  libwww-curl-perl (>= 4.05), libgraph-perl, libterm-size-perl,
-  libparse-recdescent-perl, libdigest-sha-perl
-Recommends: liblocale-gettext-perl, bzip2
-Suggests: cupt, lzma
+  libwww-curl-perl (>= 4.05), libterm-size-perl,
+  libparse-recdescent-perl, libdigest-sha-perl,
+  liblist-moreutils-perl (>= 0.23)
+Breaks: debdelta (<< 0.31)
+Recommends: liblocale-gettext-perl, bzip2, gpgv
+Suggests: cupt, lzma, debdelta (>= 0.31), dpkg-dev, dpkg-repack
 Description: alternative front-end for dpkg -- Perl modules
  This is a set of Cupt Perl modules implementing front-end to dpkg.
  .
@@ -34,7 +37,11 @@
 
 Package: cupt
 Architecture: all
-Depends: ${misc:Depends}, ${perl:Depends}, libcupt-perl (>= ${binary:Version})
+Depends: ${misc:Depends}, ${perl:Depends},
+ libcupt-perl (>= ${libcupt-perl:current}),
+ libcupt-perl (<< ${libcupt-perl:next}),
+ sensible-utils
+Suggests: libterm-readline-gnu-perl
 Description: alternative front-end for dpkg -- console interface
  This package provides a console interface to Cupt library, which is a
  re-implementation of libapt-pkg C++ library using Perl. The aim is to produce
@@ -52,6 +59,11 @@
   - pinning by package groups using shell-like patterns;
   - configurable 'depends' and 'rdepends' subcommands;
   - 'satisfy' subcommand;
-  - support of LZMA-compressed indexes.
+  - support of LZMA-compressed indexes;
+  - source versions synchronization;
+  - 'shell' subcommand (to get command history, search etc. working, install
+    the package 'libterm-readline-gnu-perl');
+  - integration with debdelta (to get it, install the package 'debdelta');
+  - system snapshots (needs packages 'dpkg-dev' and 'dpkg-repack').
  .
  Its interface is mostly like apt-get/aptitude console interface.

## cupt 1.5.13

=== debian/changelog ===
cupt (1.5.13) unstable; urgency=low

  * Cupt:
    - Cache:
      - Reading APT preferences: handle multiple package names, separated by
        spaces, correctly. Thanks to Julian Andres Klode for the report.
        (Closes: #585017)
    - System:
      - Worker:
        - Fixed passing version comparison result for pre-install hooks of
          version 2 in case of removals, re-installs and downgrades.
        - In case of circular actions error, suggest to add failed packages
          to 'cupt::worker::allow-indirect-upgrade' option.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 14 Jun 2010 21:45:29 +0300

cupt (1.5.12) unstable; urgency=low

  * Cupt:
    - System:
      - Worker:
        - Ignore Replaces when building new dependency edge because of
          Conlifcts. Dpkg purposedly violates the §7.6.2 of Debian policy.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 23 May 2010 16:43:41 +0300

cupt (1.5.11) unstable; urgency=low

  * Cupt:
    - Cache:
      - Parsing preferences: silently ignore files in preferences directory
        that don't conform to apt_preferences(5). Thanks to Eduard Bloch.
        (Closes: #578681)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 02 May 2010 19:57:11 +0300

cupt (1.5.10) unstable; urgency=low

  * cupt
    - 'why': if received only one argument, assume --installed-only.
      Thanks to James Vega for spotting. (Closes: #577646)
    - 'show': add '(on hold)' to the 'Status' line if the package is on hold.
  * Cupt:
    - Download:
      - Manager:
        - Use ITIMER_VIRTUAL instead of ITIMER_REAL for ping signals.
        - Use dedicated pipe in ping signal handler. I believe, it
          Closes: #554620. Many thanks to James Vega.
    - Cache:
      - 'verify_signature': rewrote error handling, added missing input
        checks.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 18 Apr 2010 11:02:47 +0300

cupt (1.5.9) unstable; urgency=low

  * cupt:
    - help:
      - Clarified that 'safe-upgrade' command can remove automatically
        installed packages. Thanks to intrigeri@boum.org. (Closes: #575702)
    - Action preview prompt:
      - Display a warning in case of packages on hold to be modified.
  * Cupt:
    - Cache:
      - 'get_pin': obey version holds by default by honoring new
        'cupt::cache::obey-hold' option. Thanks to intrigeri@boum.org.
        (Closes: #575704)
      - Package:
        - Don't check binary architecture for installed packages. Thanks to
          Julian Andres Klode for the report. (Closes: #574819)
    - Config:
      - ISCConfigParser:
        - Allow '.' character in option names. Thanks to intrigeri@boum.org.
          (Closes: #575715)
      - Recognize 'apt::get::build-dep-automatic' option.
      - New 'cupt::cache::obey-hold' option.
    - System:
      - Worker:
        - Set the process umask to 022. Thanks to intrigeri@boum.org.
          (Closes: #575700)
    - Download:
      - Method:
        - 'get_acquire_suboption_for_uri': setting
          'acquire::<protocol>::[<host::]proxy' to "DIRECT" to disable it
          is now supported too.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 03 Apr 2010 17:56:29 +0300

cupt (1.5.8) unstable; urgency=low

  * Cupt:
    - Cache:
      - Fixed potential crash if some chunk in the index file doesn't contain
        valid Package line.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 20 Mar 2010 15:57:19 +0200

cupt (1.5.7) unstable; urgency=low

  * Cupt:
    - Config:
      - Added packages 'openoffice.org-common', 'openoffice.org-java-common',
        'openoffice.org-writer2latex' to the list of packages which are to be
        upgraded indirectly. Thanks to Michael Stapelberg. (Closes: #573038)
  * debian/control:
    - Bumped Standards-Version to 3.8.4, no changes needed.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 13 Mar 2010 09:37:37 +0200

cupt (1.5.6) unstable; urgency=low

  * Cupt:
    - Cache:
      - 'verify_signature': detect 'no public key' error from gpgv and display
        better error message in this case.
      - 'verify_signature': don't throw fatal error on unexpected messages
        from gpgv. Thanks to Jean-Christophe Dubacq for the report.
        (Closes: #570196)
      - 'verify_signature': recognize 'KEYEXPIRED' gpgv message in addition to
        'EXPSIG' and 'EXPKEYSIG' ones.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 20 Feb 2010 15:17:10 +0200

cupt (1.5.5) unstable; urgency=medium

  * Cupt:
    - Cache:
      - Parsing extended states: fixed exiting with error on empty file
        (a regression since 1.5.4). Fixes FTBFS. (Closes: #569387).
        Urgency is set to 'medium' because of this fix.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Thu, 11 Feb 2010 22:04:16 +0200

cupt (1.5.4) unstable; urgency=low

  * Cupt:
    - Cache:
      - Parsing extended states: don't choke on unexpected fields.
    - System:
      - Worker:
        - Scheduling dpkg call sequence: fixed the false positive of
          'unable to schedule circular actions: unpack ..., unpack...' error
          in cases when specified Replaces are enough to "beat" mutual
          conflicts problem.
    - Config:
      - Added the package 'openoffice.org-core' to the list of packages which
        are to be upgraded indirectly.
      - Added the option family 'DSelect::*'. (Closes: #568706)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 08 Feb 2010 20:36:18 +0200

cupt (1.5.3) unstable; urgency=low

  * Cupt:
    - Download:
      - Manager:
        - Fixed crash when downloading URIs containing mangled symbols in
          debug mode.
    - Cache:
      - When parsing source lists, don't crash if a source line contains only
        one or two words.
    - Config:
      - get_list: return an empty list, not a list of one undefined entry in
        case of non-defined optional option.
    - Worker:
      - Fixed calculating dependencies for 'remove' subactions of upgrade


=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
   libwww-curl-perl (>= 4.05), liblist-moreutils-perl (>= 0.23)
 Maintainer: Eugene V. Lyubimkin <jackyf@debian.org>
 Homepage: http://wiki.debian.org/Cupt
-Standards-Version: 3.8.3
+Standards-Version: 3.8.4
 Vcs-Git: git://github.com/jackyf/cupt.git
 Vcs-Browser: http://github.com/jackyf/cupt/tree/master

=== debian/rules ===
#!/usr/bin/make -f

PERL ?= /usr/bin/perl

VERSION := $(shell dpkg-parsechangelog | sed -ne 's/Version: *\(.*\) *$$/\1/p')
MAJOR_VERSION = $(shell echo $(VERSION) | cut -f 1 -d .)
MINOR_VERSION = $(shell echo $(VERSION) | cut -f 2 -d .)
NEXT_MINOR_VERSION = $(shell expr $(MINOR_VERSION) + 1 2>/dev/null)

override_build:
	$(PERL) Makefile.PL INSTALLDIRS=vendor

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(CURDIR)/debian/libcupt-perl
	# produce additional man pages for cupt
	$(PERL) debian/install_pods
	install -m644 scripts/bash_completion $(CURDIR)/debian/cupt/etc/bash_completion.d/cupt

override_dh_gencontrol:
	dh_gencontrol -- \
		-Vlibcupt-perl:current="$(MAJOR_VERSION).$(MINOR_VERSION)" \
		-Vlibcupt-perl:next="$(MAJOR_VERSION).$(NEXT_MINOR_VERSION)"

%:
	dh $@

## cupt 1.5.14.1

=== debian/changelog ===
cupt (1.5.14.1) unstable; urgency=low

  * Cupt:
    - Config:
      - Fixed ignoring 'APT::Never-MarkAuto-Sections' option.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 25 Sep 2010 22:17:33 +0300

cupt (1.5.14) unstable; urgency=low

  * doc:
    - cupt_vs_apt:
      - Documented not handling the difference between 'specific' and
        'general' APT pin types. (Closes: #586347)
  * Cupt:
    - Cache:
      - ArchitecturedRelation:
        - Implemented architecture wildcards support. (Closes: #587354)
  * debian/control:
    - Bumped Standards-Version to 3.9.0, no changes needed.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Thu, 08 Jul 2010 21:20:35 +0300

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
   libwww-curl-perl (>= 4.05), liblist-moreutils-perl (>= 0.23)
 Maintainer: Eugene V. Lyubimkin <jackyf@debian.org>
 Homepage: http://wiki.debian.org/Cupt
-Standards-Version: 3.8.4
+Standards-Version: 3.9.0
 Vcs-Git: git://github.com/jackyf/cupt.git
 Vcs-Browser: http://github.com/jackyf/cupt/tree/master

## cupt 2.0.1

=== debian/changelog ===
cupt (2.0.1) unstable; urgency=low

  * lib:
    - download/manager:
      - Give a warning instead of an error on the systems where the socket
        option SO_RCVTIMEO is not supported. Thanks to Jonathan Nieder for
        the analysis.
    - [Jonathan Nieder] Don't check for WIFCONTINUED. (Closes: #623159)
  * debian:
    - control:
      - Fixed typo 'arternative' in some short descriptions.
  * doc:
    - reference:
      - Hide 'CUPT_API' macro in declarations.
      - Hide 'CUPT_*' macro definitions.
    - tutorial:
      - Documented repository cache layout incompatibility with recent
        versions of APT.
      - Documented a tuning of resolver's maximum solution count.
      - Documented package archives cleaning.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Mon, 25 Apr 2011 12:15:20 +0300

cupt (2.0.0) unstable; urgency=low

  * Upload to unstable.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 16 Apr 2011 12:48:44 +0300

cupt (2.0.0~rc2) experimental; urgency=medium

  * lib:
    - Make sure that std::min() receives arguments of the same type.
      Fixes FTBFS on some architectures. (Closes: #622061)
    - download/uri:
      - 'getHost': fixed to not include a port to the answer. Thanks to
        Julian Andres Klode for the report. The regression was introduced
        in 2.0.0~alpha1. (Closes: #621853)
      - 'getHost': fixed to not include credentials to the answer.
        The regression was introduced in 2.0.0~alpha1.
    - system/resolvers/native:
      - Fixed applying penalty on removing essential packages even if proposed
        version is not essential anymore.
      - Made the penalty on removing essential packages not pin-dependent and
        much bigger.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Tue, 12 Apr 2011 19:46:59 +0300

cupt (2.0.0~rc1) experimental; urgency=low

  * console:
    - Action preview prompt:
      - Allow specifying several package expressions under 'a' choice before
        re-running a resolver.
    - 'dist-upgrade':
      - [Jonathan Nieder] Pre-upgrade 'cupt' package first, not
        'cupt-experimental'. Fixes a regression introduced in 2.0.0~beta2.
    - 'help':
      - Removed the temporary message that 'snapshot' subcommand is not
        implemented, it's implemented since 2.0.0~alpha3.
    - 'config-dump':
      - Print empty value list first for all list options.
    - Added '--as-needed' to link flags.
  * lib:
    - Always set 'close-on-exec' flag for internal pipes.
    - system/resolvers/native:
      - Fixed an algorithmic bug in calculating error trees when no solutions
        are found, which might lead to incorrect trees sometimes.
      - Output a warning about no effect when 'apt::install-<X>' option is set
        but 'cupt::resolver::keep-<X>' option is unset.
      - Fixed an endless loop when calculating error trees in some rare cases.
      - Consider all binary builds (not only selected one) of some source
        package version to be already synchronized with any binary build of
        the related package. Fixes a bug which was present since an initial
        implementation of synchronizing source versions.
      - Changed scoring system once again, to overcome some design bugs in
        previous one.
      - Try to make backtracking more effective by processing "derived"
        problems closer to their "parents".
    - file:
       - Always set 'close-on-exec' flag for opened file descriptors.
    - config:
      - Recognize 'acquire::cdrom::*' variables.
      - The option is 'cupt::cache::obey-hold' is renamed to
        'cupt::cache::pin::addendums::hold'.
      - New option 'cupt::cache::pin::addendums::not-automatic'.
      - The option group 'cupt::resolver::tune-score::*' is renamed to
        'cupt::resolver::score::*'.
      - Deleted the option 'cupt::resolver::quality-bar', it's superseded by
        the option 'cupt::resolver::score::quality-adjustment'.
      - New option 'cupt::cache::pin::addendums::downgrade'.
      - The option 'cupt::resolver::synchronize-source-versions' is renamed
        to 'cupt::resolver::synchronize-by-source-versions'.
    - download/manager:
      - Pass the right pointer to setitimer() when disabling SIGALRM. Thanks
        to Jonathan Nieder for the report. (Closes: #619727)
      - Fixed undefined behavior in handling duplicated downloads.
        Fixes a regression introduced in 2.0.0~alpha1.
    - cache:
      - Apply an additional pin priority penalty for not automatic releases.
    - Set of close-on-exec flag changes above Closes: #619650. Thanks to
      Jonathan Nieder for the report and an initial patch set.
    - Non-API symbols are not exported anymore.
  * doc:
    - reference:
      - Removed protected members of cupt::cache::Package and its subclasses
        from the documentation, they exist for internal usage only.
    - tutorial:
      - Created.
  * scripts:
    - bash_completion:
      - Complete 'cupt', not 'cupt-experimental'. Fixes a regression
        introduced in 2.0.0~beta2.
      - Pre-filter package names using 'cupt pkgnames <start>', it's faster
        than supplying a full list to compgen.
      - Remove arguments completion for 'config-dump' subcommand, it does not
        accept arguments since 2.0.0~alpha1.
      - Complete also option names after '--option' and '-o'.
  * downloadmethods:
    - Added '--as-needed' to link flags.
  * debian:
    - control:
      - Build-depend on 'txt2tags'.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 09 Apr 2011 18:28:51 +0300

cupt (2.0.0~beta2) experimental; urgency=low

  * console:
    - Action preview prompt: support 'ProcessTriggers' action.
    - New experimental subcommand 'tar-metadata'.
    - 'showsrc':
      - Output also Uploaders when not empty. Fixes a regression introduced
        in 2.0.0~alpha1.
    - When selecting a version by archive/codename, throw an error if more
      than one matching version is found.
  * lib:
    - cache/binaryversion:


=== debian/control ===
Source: cupt
Section: admin
Priority: optional
Build-Depends: debhelper (>= 7.0.50), g++-4.5, libboost-program-options1.42-dev,
  libboost1.42-dev, libreadline6-dev, chrpath, libcurl4-gnutls-dev (>= 7.19.4),
  cmake (>= 2.6), doxygen, libgcrypt11-dev, txt2tags
Maintainer: Eugene V. Lyubimkin <jackyf@debian.org>
Homepage: http://wiki.debian.org/Cupt
Standards-Version: 3.9.1
Vcs-Git: git://github.com/jackyf/cupt.git
Vcs-Browser: https://github.com/jackyf/cupt/tree/develop

Package: libcupt2-0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libcupt2-0-experimental
Breaks: debdelta (<< 0.31)
Recommends: libcupt2-0-downloadmethod-curl | libcupt2-0-downloadmethod-wget, bzip2, gpgv
Suggests: cupt, lzma, debdelta (>= 0.31), dpkg-dev, dpkg-repack
Description: alternative front-end for dpkg -- runtime library
 This is a Cupt library implementing front-end to dpkg.
 .
 Provides:
  - parsing and manipulating configuration info;
  - parsing indexes metadata info;
  - version strings comparison;
  - inspection of the binary and source package' versions;
  - parsing and querying info about installed packages;
  - parsing and working with relations and relation expressions;
  - download manager and downloaders for some schemes;
  - problem resolver;
  - worker for modifying system state.
 .
 See also description of 'cupt' package for more information.

Package: libcupt2-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libcupt2-0 (= ${binary:Version})
Conflicts: libcupt2-dev-experimental
Suggests: libcupt2-doc
Description: alternative front-end for dpkg -- development files
 This package provides headers for Cupt library.
 .
 See also description of libcupt2-0 package.

Package: libcupt2-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: alternative front-end for dpkg -- library documentation
 This package provides documentation for Cupt library.
 .
 See also description of libcupt2-0 package.

Package: cupt
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libcupt2-0 (>= ${binary:Version})
Suggests: sensible-utils, libreadline6
Description: alternative front-end for dpkg -- console interface
 This package provides a console interface to Cupt library, which is a
 re-implementation of libapt-pkg C++ library. The aim is to produce
 more strict, more robust, less buggy front-end than APT.
 .
 Cupt uses the same APT infrastructure, e.g. index files, deb cache archive
 files, configuration files. It understands some of widely used APT options.
 .
 Some features:
  - strict full-case resolver;
  - resolver reasons tracking;
  - command-line and APT-like option name checker;
  - case-sensitive search;
  - pinning by source package name;
  - pinning by package groups using shell-like patterns;
  - configurable 'depends' and 'rdepends' subcommands;
  - 'satisfy' subcommand;
  - support of LZMA-compressed indexes;
  - source versions synchronization;
  - 'shell' subcommand (to get command history, search etc. working, install
    the package 'libreadline6');
  - integration with debdelta (to get it, install the package 'debdelta');
  - system snapshots (needs packages 'dpkg-dev' and 'dpkg-repack').
 .
 Its interface is mostly like apt-get/aptitude console interface.

Package: libcupt2-0-downloadmethod-curl
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: alternative front-end for dpkg -- libcurl download method
 This package provides http(s) and ftp download handlers for Cupt library
 using libcurl.
 .
 See also description of libcupt2-0 package.

Package: libcupt2-0-downloadmethod-wget
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, wget
Description: alternative front-end for dpkg -- wget download method
 This package provides http(s) and ftp download handlers for Cupt library
 using wget.
 .
 See also description of libcupt2-0 package.

=== debian/rules ===
#!/usr/bin/make -f

PERL ?= /usr/bin/perl

override_dh_auto_configure:
	cmake -DLOCAL:bool=OFF -DCMAKE_INSTALL_PREFIX=$(CURDIR)/debian/tmp/usr -DOPTIMIZE=2 ./

override_dh_auto_install:
	$(MAKE) install
	chrpath --delete $(CURDIR)/debian/tmp/usr/bin/cupt
	# produce additional man pages for cupt
	$(PERL) debian/install_pods
	install -m644 scripts/bash_completion $(CURDIR)/debian/cupt/etc/bash_completion.d/cupt

%:
	dh $@

## cupt 2.0.2

=== cpp/downloadmethods/CMakeLists.txt ===
--- 
+++ 
@@ -12,4 +12,8 @@
 add_precompiled_header(debdelta)
 target_link_libraries(debdelta cupt2)
 
-install(TARGETS wget curl debdelta DESTINATION lib/cupt2-${CUPT_SOVERSION}/downloadmethods)
+add_library(file MODULE file.cpp)
+add_precompiled_header(file)
+target_link_libraries(file cupt2)
+
+install(TARGETS file wget curl debdelta DESTINATION lib/cupt2-${CUPT_SOVERSION}/downloadmethods)

=== debian/changelog ===
cupt (2.0.2) unstable; urgency=low

  * lib:
    - download/methodfactory:
      - Don't try to unload a module twice if it was loaded successfully but
        no needed symbols were found.
    - download/uri:
      - Correctly handle URIs with tree slashes, such as 'file:///...'.
  * downloadmethods:
    - file:
      - Implemented. Fixes a regression since 2.0.0~alpha1. (Closes: #624216)
  * doc:
    - reference:
      - 'File::getBlock': documented an output value of the 'size' parameter.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 30 Apr 2011 14:31:22 +0300

## cupt 2.1.0

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 	message(FATAL_ERROR "missing GNU Readline library")
 ENDIF(NOT EXISTS /usr/include/readline/readline.h)
 
-set(CMAKE_CXX_FLAGS "-Wall -Wextra -std=gnu++0x  -fPIC")
+set(CMAKE_CXX_FLAGS "-Wall -Wextra -std=gnu++0x -fPIC -I${CMAKE_SOURCE_DIR}/cpp/ -include common/common.hpp")
 
 OPTION(VERBOSE "is build verbose")
 IF(VERBOSE)
@@ -54,16 +54,6 @@
 set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed")
 set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--as-needed")
 
-MACRO(ADD_PRECOMPILED_HEADER Target)
-	get_target_property(Sources ${Target} SOURCES)
-	# message(STATUS "Sources found for ${Target}: ${Sources}")
-	SET_SOURCE_FILES_PROPERTIES(${Sources}
-		PROPERTIES
-		COMPILE_FLAGS "-include ../precompiled/precompiled.hpp -Winvalid-pch"
-	)
-	add_dependencies(${Target} precompiled)
-ENDMACRO(ADD_PRECOMPILED_HEADER)
-
 set(CUPT_SOVERSION 0)
 
 # detect version from debian/changelog
@@ -84,6 +74,6 @@
 
 add_subdirectory(console)
 add_subdirectory(lib)
-add_subdirectory(precompiled)
+# add_subdirectory(precompiled)
 add_subdirectory(downloadmethods)

=== debian/changelog ===
cupt (2.1.0) unstable; urgency=low

  * console:
    - New 'showauto' subcommand.
  * lib:
    - cache/relation:
      - Relation: new copy constructor from Relation&&.
      - RelationLine: new method 'operator=(RelationLine&&)'.
      - RelationExpression: new copy constructor from RelationExpression&&.
      - ArchitecturedRelation: new copy constructor from
        ArchitecturedRelation&&.
      - ArchitecturedRelationExpression: new copy constructor from
        ArchitecturedRelationExpression&&.
      - ArchitecturedRelationLine: new method
        'operator=(ArchitecturedRelationLine&&)'.
    - system/worker:
      - A small speed-up of generating dpkg action sequences for large queries.
      - RAM usage optimizations.
      - [Julian Andres Klode] Introduced a support for xz-compressed index
        files. (Closes: #623129)
      - Create lists directory if it does not exist.
    - config:
      - Be more clear in configuration file error messages that they talk
        about syntax errors.
      - New configuration variable 'cupt::directory::state::lists'.
      - Changed the default value of the variable
        'cupt::update::keep-bad-signatures' to 'yes'.
      - New configuration variable
        'cupt::resolver::score::removal-of-essential'.
    - cache:
      - Support regular expressions in pin preferences. Thanks to
        Julian Andres Klode for the suggestion. (Closes: #587478)
      - When skipping an index or translation file processing due to an error,
        use a human-readable alias in the warning message.
      - Mark structures and methods, which are related to local and remote
        locations of internal cache files, as deprecated.
    - system/resolvers/native:
      - RAM usage optimizations.
      - Do not depend on cache memoizing. Fixes a regression introduced in
        2.0.0~beta1.
      - Apply a penalty for removal of an essential package regardless of the
        score sign.
    - cache/{source,binary}version:
      - Don't error out, only print a warning for unrecognized values of the
        'Priority' field. Fixes a regression introduced in 2.0.0~alpha1.
  * debian:
    - control:
      - Relax Boost build requirements to match 1.42 and higher, not only
        1.42.
      - Vcs-Browser: the main branch is now 'master' again.
      - Bumped debhelper build-dependency to (>= 7.4.10) to use --parallel.
      - Bumped Standards-Version to 3.9.2, no changes needed.
    - rules:
      - Support 'noopt' in DEB_BUILD_OPTIONS. (Closes: #628405)
      - Support 'parallel=N' in DEB_BUILD_OPTIONS.
  * Support out-of-tree builds. (Closes: #623115)
  * Switched to Cupt-specific directory 'cupt::directory::state::lists' for
    index lists.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 29 May 2011 12:46:37 +0300
